class WordFinder extends WordQuiz {
	add(parentitem, rows) {
		const catitem = put(parentitem, 'ul');
		rows.forEach(ref => {
			const [title, level, imgid] = this.data[ref];
			const worditem = put(catitem, 'li');
			const figitem = put(worditem, 'figure');
			if (imgid) {
				put(figitem, 'img[src=$]', `/data/word/32/${imgid}.jpg`);
			}
			if (title) {
				let html = title.replace(/\/(.*)/, ' <small>($1)</small>');
				put(figitem, 'figcaption', {
					innerHTML: html,
				});
			}
			let levelpart = level <= 1 && this.cats[ref] && this.cats[ref].length > 1;
			if (levelpart) {
				put(worditem, '.large');
			}
			if (this.cats[ref]) {
				// delve into subcategory
				put(worditem, '.parent');
				this.add(worditem, this.cats[ref].sort((a, b) => {
					const [worda, wordb] = [this.data[a], this.data[b]];
					return (worda[1] % 1) - (wordb[1] % 1)
						|| worda[0].localeCompare(wordb[0]);
				}));
			}
		});
	}

	setup() {
		this.gallery = document.getElementById('gallery');
		put(this.gallery, '-p', 'Under construction.');
		this.add(this.gallery, this.preset.cat ? [this.preset.cat] : this.cats[null]);
	}

	stop() {}
};
